<?php
/**
 * Ipay88
 * @author Ipay88
 * @package Ipay88\Lib
 */

class ipay88_ATMTransfer_Indonesia
{
    const URL_PAYMENT_PRODUCTION 				= 'https://payment.ipay88.co.id/epayment/entry.asp';
    const URL_PAYMENT_SANDBOX    				= 'https://sandbox.ipay88.co.id/epayment/entry.asp';

    const PAYMENT_METHOD_ENABLE 				= 1;
    const PAYMENT_METHOD_DISABLE				= 2;

	// atm-transfer	
	const PAYMENT_METHOD_BCA					= 25;
	const PAYMENT_METHOD_BNI 				    = 26;
	const PAYMENT_METHOD_CIMB				    = 27;
	const PAYMENT_METHOD_MANDIRI				= 17;
	const PAYMENT_METHOD_MAYBANK				= 9;
	const PAYMENT_METHOD_PERMATA				= 31;
    const PAYMENT_METHOD_BCA_VA_FASPAY          = 30;
    const PAYMENT_METHOD_MANDIRI_VA_FASPAY      = 69;
    const PAYMENT_METHOD_BRI_VA_FASPAY          = 61;
    const PAYMENT_METHOD_BNI_VA_FASPAY          = 68;
	
    const MERCHANT_CODE 						= 'ipay88_merchant_code';
    const MERCHANT_KEY  						= 'ipay88_merchant_key';
    const PAYMENT_MODE  						= 'ipay88_payment_mode';
	
	const PAYMENT_METHOD_BCA_CONFIG				= 'ipay88_bca_config';
	const PAYMENT_METHOD_BNI_CONFIG			    = 'ipay88_bni_config';
	const PAYMENT_METHOD_CIMB_CONFIG		    = 'ipay88_cimb_config';
	const PAYMENT_METHOD_MANDIRI_CONFIG			= 'ipay88_mandiri_config';
	const PAYMENT_METHOD_MAYBANK_CONFIG			= 'ipay88_maybank_config';
	const PAYMENT_METHOD_PERMATA_CONFIG			= 'ipay88_permata_config';
    const PAYMENT_METHOD_BCA_VA_FASPAY_CONFIG   = 'ipay88_bca_va_faspay_config';
    const PAYMENT_METHOD_MANDIRI_VA_FASPAY_CONFIG = 'ipay88_mandiri_va_faspay_config';
    const PAYMENT_METHOD_BRI_VA_FASPAY_CONFIG     = 'ipay88_bri_va_faspay_config';
    const PAYMENT_METHOD_BNI_VA_FASPAY_CONFIG     = 'ipay88_bni_va_faspay_config';
			
	const PAYMENT_METHOD_BCA_CONFIG_LABEL		= 'BCA v1';
	const PAYMENT_METHOD_BNI_CONFIG_LABEL	    = 'BNI v1';
	const PAYMENT_METHOD_CIMB_CONFIG_LABEL	    = 'CIMB v1';
	const PAYMENT_METHOD_MANDIRI_CONFIG_LABEL   = 'Mandiri v1';
	const PAYMENT_METHOD_MAYBANK_CONFIG_LABEL   = 'Maybank v1';
	const PAYMENT_METHOD_PERMATA_CONFIG_LABEL   = 'Permata v1';
    const PAYMENT_METHOD_BCA_VA_FASPAY_CONFIG_LABEL = 'BCA VA v2';
    const PAYMENT_METHOD_MANDIRI_VA_FASPAY_CONFIG_LABEL = 'Mandiri VA v2';
    const PAYMENT_METHOD_BRI_VA_FASPAY_CONFIG_LABEL     = 'BRI VA v2';
    const PAYMENT_METHOD_BNI_VA_FASPAY_CONFIG_LABEL     = 'BNI VA v2';
	
	// function
    public function getBanksConfigs() 
	{
		return array(	self::PAYMENT_METHOD_BCA_CONFIG,          			
        				self::PAYMENT_METHOD_BNI_CONFIG,
        				self::PAYMENT_METHOD_CIMB_CONFIG,
        				self::PAYMENT_METHOD_MANDIRI_CONFIG,
        				self::PAYMENT_METHOD_MAYBANK_CONFIG,
        				self::PAYMENT_METHOD_PERMATA_CONFIG,
                        self::PAYMENT_METHOD_BCA_VA_FASPAY_CONFIG,
                        self::PAYMENT_METHOD_MANDIRI_VA_FASPAY_CONFIG,
                        self::PAYMENT_METHOD_BRI_VA_FASPAY_CONFIG,
                        self::PAYMENT_METHOD_BNI_VA_FASPAY_CONFIG
					);
    }

    public function getFieldsConfigs() 
	{
        return array(	self::MERCHANT_CODE,
						self::MERCHANT_KEY,
						self::PAYMENT_MODE,
			
						self::PAYMENT_METHOD_BCA_CONFIG,    
						self::PAYMENT_METHOD_BNI_CONFIG,    	
						self::PAYMENT_METHOD_CIMB_CONFIG,    
						self::PAYMENT_METHOD_MANDIRI_CONFIG,  
						self::PAYMENT_METHOD_MAYBANK_CONFIG, 
						self::PAYMENT_METHOD_PERMATA_CONFIG,			
                        self::PAYMENT_METHOD_BCA_VA_FASPAY_CONFIG,
                        self::PAYMENT_METHOD_MANDIRI_VA_FASPAY_CONFIG,
                        self::PAYMENT_METHOD_BRI_VA_FASPAY_CONFIG,
                        self::PAYMENT_METHOD_BNI_VA_FASPAY_CONFIG			
        			);
    }

    protected $paymentMethod;
	protected $description;
	protected $banks;
    protected $bankKeyConfig;
    protected $paymentId;
    protected $bankName;
    protected $logo;
    protected $imagePath;
    protected $bankEnabled;
    
	// @return array
    public function getBankEnabled()
    {
        return $this->bankEnabled;
    }

    // @param mixed $bankEnabled
    public function setBankEnabled($bankEnabled)
    {
        $this->bankEnabled = $bankEnabled;
    }

    // @return mixed
    public function getPaymentMethod()
    {
        return $this->paymentMethod;
    }

    // @param mixed $paymentMethod
    public function setPaymentMethod($paymentMethod)
    {
        $this->paymentMethod = $paymentMethod;
    }

    // @return mixed
    public function getBanks()
    {
        return $this->banks;
    }

    // @param mixed $banks
    public function setBanks($banks)
    {
        $this->banks = $banks;
    }

    // @return mixed
    public function getBankKeyConfig()
    {
        return $this->bankKeyConfig;
    }

    // @param mixed $bankKeyConfig
    public function setBankKeyConfig($bankKeyConfig)
    {
        $this->bankKeyConfig = $bankKeyConfig;
    }

    // @return mixed
    public function getPaymentId()
    {
        return $this->paymentId;
    }

    // @param mixed $paymentId
    public function setPaymentId($paymentId)
    {
        $this->paymentId = $paymentId;
    }

    // @return mixed
    public function getBankName()
    {
        return $this->bankName;
    }

    // @param mixed $bankName
    public function setBankName($bankName)
    {
        $this->bankName = $bankName;
    }

	// @return mixed
    public function getLogo()
    {
        return $this->logo;
    }

    // @param mixed $logo
    public function setLogo($logo)
    {
        $this->logo = $logo;
    }

    // @return mixed
    public function getImagePath()
    {
        return $this->imagePath;
    }

    // @param mixed $imagePath
    public function setImagePath($imagePath)
    {
        $this->imagePath = $imagePath;
    }

    // Payment methods, please view technical spec for latest update.
    protected $pMethod = array(
  
		self::PAYMENT_METHOD_BCA_CONFIG  => 
		array(	'paymentId' => self::PAYMENT_METHOD_BCA,
            	'name' 		=> 'BCA',
            	'logo' 		=> 'bca.png'),
				
		self::PAYMENT_METHOD_BNI_CONFIG => 
		array(	'paymentId' => self::PAYMENT_METHOD_BNI,
            	'name' 		=> 'BNI',
            	'logo' 		=> 'bni.png'),
                
		self::PAYMENT_METHOD_CIMB_CONFIG => 
		array(	'paymentId' => self::PAYMENT_METHOD_CIMB,
            	'name' 		=> 'CIMB',
            	'logo' 		=> 'cimb.png'),
                
		self::PAYMENT_METHOD_MANDIRI_CONFIG => 
		array(	'paymentId' => self::PAYMENT_METHOD_MANDIRI,
            	'name' 		=> 'Mandiri',
            	'logo' 		=> 'mandiri.png'),
                
        self::PAYMENT_METHOD_MAYBANK_CONFIG => 
        array(	'paymentId' => self::PAYMENT_METHOD_MAYBANK,
                'name' 		=> 'Maybank',
                'logo' 		=> 'maybank.png'),
                
        self::PAYMENT_METHOD_PERMATA_CONFIG => 
        array(	'paymentId' => self::PAYMENT_METHOD_PERMATA,
                'name' 		=> 'Permata',
                'logo' 		=> 'permata.png'),
        
        self::PAYMENT_METHOD_BCA_VA_FASPAY_CONFIG =>
        array(  'paymentId' => self::PAYMENT_METHOD_BCA_VA_FASPAY,
                'name' => 'BCA VA',
                'logo' => 'bca.png'),

        self::PAYMENT_METHOD_MANDIRI_VA_FASPAY_CONFIG =>
        array(  'paymentId' => self::PAYMENT_METHOD_MANDIRI_VA_FASPAY,
                'name' => 'MANDIRI VA',
                'logo' => 'mandiri.png'),

        self::PAYMENT_METHOD_BRI_VA_FASPAY_CONFIG =>
        array(  'paymentId' => self::PAYMENT_METHOD_BRI_VA_FASPAY,
                'name' => 'BRI VA',
                'logo' => 'bri.png'),
        
        self::PAYMENT_METHOD_BNI_VA_FASPAY_CONFIG =>
        array(  'paymentId' => self::PAYMENT_METHOD_BNI_VA_FASPAY,
                'name' => 'BNI VA',
                'logo' => 'bni.png')
    );

    // @return array
    public function getPmethod() 
	{
        return $this->pMethod;
    }

    // Payment methods, please view technical spec for latest update.
    public $paymentMethods = array(
						
		self::PAYMENT_METHOD_BCA_CONFIG  => 
		array(	'name' 		=> 'BCA',
            	'logo' 		=> 'bca.png'),
				
		self::PAYMENT_METHOD_BNI_CONFIG => 
		array(	'name' 		=> 'BNI',
            	'logo' 		=> 'bni.png'),
				
		self::PAYMENT_METHOD_CIMB_CONFIG => 
		array(	'name' 		=> 'CIMB',
            	'logo' 		=> 'cimb.png'),
				
		self::PAYMENT_METHOD_MANDIRI_CONFIG => 
		array(	'name' 		=> 'Mandiri',
                'logo' 		=> 'mandiri.png')
                ,
				
		self::PAYMENT_METHOD_MAYBANK_CONFIG => 
		array(	'name' 		=> 'Maybank',
                'logo' 		=> 'maybank.png')
                ,
				
		self::PAYMENT_METHOD_PERMATA_CONFIG => 
		array(	'name' 		=> 'Permata',
            	'logo' 		=> 'permata.png'),
        
        self::PAYMENT_METHOD_BCA_VA_FASPAY_CONFIG =>
        array( 'name' => 'BCA VA',
                'logo' => 'bca.png'),

        self::PAYMENT_METHOD_MANDIRI_VA_FASPAY_CONFIG =>
        array( 'name' => 'MANDIRI VA',
                'logo' => 'mandiri.png'),

        self::PAYMENT_METHOD_BRI_VA_FASPAY_CONFIG =>
        array( 'name' => 'BRI VA',
                'logo' => 'bri.png'),
        
        self::PAYMENT_METHOD_BNI_VA_FASPAY_CONFIG =>
        array( 'name' => 'BNI VA',
                'logo' => 'bni.png')
	);

    // @param $key
    // @return null
    public function getPaymentMethodInfoByKey($key) 
	{
        if(isset($this->pMethod[$key])) 
		{
            return $this->pMethod[$key];
        }
        
		return null;
    }

    // @param $id
    // @return null
    public function getPaymentMethodInfoById($id) 
	{
        if(isset($this->pMethod[$id])) 
		{
            return $this->pMethod[$id];
        }
        
		return null;
    }

    public function __construct($options = null)
    {
    }

	//payment checkout
    public function getWiget($banks, $description, $imagePath, $auto = false) 
	{
        $bankConfigurations = $banks;
		
        $html = $description.'<br><br>			
		<p class="form-row">
		<label for="ipay88_payment_type">PaymentType
		<span class="required">*</span></label>
		</p>
		
		<div class="payment_method_ipay88">
		<fieldset>
		<legend>Please choose one to pay</legend>';
				
		if(is_array($bankConfigurations) && count($bankConfigurations)) 
		{
			foreach ($bankConfigurations as $key => $config) 
			{
				if($config) 
				{
					$bank = $this->getPaymentMethodInfoByKey($key);
					
					if(is_array($bank) && count($bank)) 
					{
						$paymentId	= isset($bank['paymentId']) ? $bank['paymentId'] : '';
						$name 		= isset($bank['name']) ? $bank['name'] : '';
						$logo 		= $imagePath . DIRECTORY_SEPARATOR . (isset($bank['logo']) ? $bank['logo'] : '');

						$html .= '<div><label style="margin-bottom:5px;display:inline-flex;align-items:center;">
						<input type="radio" name="ipay88_bank_payment_method" value="'.$paymentId.'">
						<img class="ipay88_bank_payment_method" src="'.$logo.'" alt="'.$name.'" style="float:none; max-width:6.5em; margin-left:1em;"></label></div>';
					}
				}
			}
		}
		
		$html .= '</fieldset></div>';
		
        return $html;
    }
}